{ nix-minecraft, ... }:

let
  mkModpack =
    { inputs }:
    let
      nixpkgs = inputs.nixpkgs;
      lib = nixpkgs.lib;

      eachSystem =
        fn: lib.genAttrs lib.systems.flakeExposed (system: fn (import nixpkgs { inherit system; }));

      mkPackages = pkgs: {
        modpack = nix-minecraft.legacyPackages.${pkgs.system}.fetchPackwizModpack {
          url = inputs.self;
        };
      };

      overlay = final: prev: mkPackages prev;
    in
    {
      inherit overlay;
      packages = eachSystem mkPackages;
      devShells = eachSystem (pkgs: {
        default = pkgs.mkShell {
          buildInputs = with pkgs; [
            packwiz
          ];
        };
      });
    };
in
mkModpack
